dofile("Base.rte/Constants.lua")
require("AI/NativeHumanAI")
function Create(self)
	self.AI = NativeHumanAI:Create(self)
	self.MaxHealthEnergy = 100
	self.CurrentHE = 0
	self.sound = false
	self.HERestoreTimer = Timer()

	self.HealTimer = Timer()
	self.HealTimer:SetSimTimeLimitMS(230)
	self.CrossTimer = Timer()
	self.CrossTimer:SetSimTimeLimitMS(800)
end
function Update(self)
	self.Meter = CreateAEmitter("Health Energy Meter")
	self.Meter.Pos = self.Pos + Vector(0, -30)
	self.Meter.Frame = 0 + math.ceil(self.CurrentHE / 11)
	MovableMan:AddParticle(self.Meter)
	self.Frame = 0 + math.ceil(self.CurrentHE / 10)
	if self.CurrentHE < self.MaxHealthEnergy and self.Sharpness == 0 and self.HERestoreTimer:IsPastSimMS(1000) then
		self.CurrentHE = self.CurrentHE + 1
		self.sound = true
		self.HERestoreTimer:Reset()
	end
	if self.Sharpness == 1 and self.CurrentHE >= 1 and self.HealTimer:IsPastSimTimeLimit() then
		self.CurrentHE = self.CurrentHE - 1
		self.HealTimer:Reset()
		if self.HealTarget then
			local targetFound = false
			if
				MovableMan:IsActor(self.HealTarget)
				and self.HealTarget.Health < 100
				and self.HealTarget.Vel.Largest < 6
			then
				local Trace = SceneMan:ShortestDistance(self.Pos, self.HealTarget.Pos, false)
				if Trace.Magnitude - self.HealTarget.Radius < 100 then
					if
						SceneMan:CastObstacleRay(
							self.EyePos,
							Trace,
							Vector(),
							Vector(),
							self.ID,
							self.IgnoresWhichTeam,
							rte.grassID,
							5
						) < 0
					then
						-- We have LOS to the target
						targetFound = true
					end
				end
			end
			if targetFound then
				self.HealTarget.Health = math.min(self.HealTarget.Health + 1, 100)
				self.HealTarget:RemoveWounds(1)
				if self.CrossTimer:IsPastSimTimeLimit() then
					self.CrossTimer:Reset()
					local Cross = CreateMOSParticle("Particle Heal Effect", "Base.rte")
					if Cross then
						Cross.Pos = self.HealTarget.AboveHUDPos + Vector(0, 1)
						MovableMan:AddParticle(Cross)
						local healglow = CreateMOPixel("Health Energy Glow")
						healglow.Pos = self.HealTarget.Pos
						MovableMan:AddParticle(healglow)
					end
				end
			else
				self.HealTarget = nil
				local healingOFF = CreateAEmitter("Healing Off")
				healingOFF.Pos = self.Pos
				MovableMan:AddParticle(healingOFF)
				self.Sharpness = 0
			end
		else
			for Act in MovableMan.Actors do
				if Act.Team == self.Team and Act.Health < 100 and Act.Vel.Largest < 4 then
					local Trace = SceneMan:ShortestDistance(self.Pos, Act.Pos, false)
					if Trace.Magnitude - Act.Radius < 80 then
						if
							SceneMan:CastObstacleRay(
								self.EyePos,
								Trace,
								Vector(),
								Vector(),
								self.ID,
								self.IgnoresWhichTeam,
								0,
								3
							) < 0
						then
							self.HealTarget = Act
							break
						end
					end
				end
			end
		end
	end
	if self.CurrentHE == 0 and self.sound == true then
		self.Sharpness = 0
		self.sound = false
		local healingOFF = CreateAEmitter("Healing Off")
		healingOFF.Pos = self.Pos
		MovableMan:AddParticle(healingOFF)
	end
end
function UpdateAI(self)
	self.AI:Update(self)
end
